"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.LocaleProviderConsumer = void 0;

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _translateMaker = _interopRequireDefault(require("translate-maker"));

const {
  Provider,
  Consumer
} = (0, _react.createContext)({});
const LocaleProviderConsumer = Consumer;
exports.LocaleProviderConsumer = LocaleProviderConsumer;

class LocaleProvider extends _react.Component {
  constructor(props) {
    super(props);
    (0, _defineProperty2.default)(this, "t", (path, attrs, defaultValue) => this.get(path, attrs, defaultValue));
    (0, _defineProperty2.default)(this, "dataChanged", () => {
      this.forceUpdate();
    });
    (0, _defineProperty2.default)(this, "localeChanged", () => {
      this.forceUpdate();
    });
    const {
      translate,
      locale,
      namespace,
      children,
      controlled
    } = props,
          rest = (0, _objectWithoutProperties2.default)(props, ["translate", "locale", "namespace", "children", "controlled"]);
    const instance = translate || new _translateMaker.default(rest);
    this.state = {
      translate: instance
    };

    if (locale) {
      instance.setLocale(locale, namespace);
    }
  }

  componentDidMount() {
    const {
      translate
    } = this.state;
    translate.on('locale', this.localeChanged);
    translate.on('changed', this.dataChanged);
  }

  componentWillReceiveProps(newProps) {
    const {
      locale,
      namespace
    } = this.props;
    const {
      translate
    } = this.state;

    if (newProps.controlled) {
      if (newProps.locale !== locale) {
        translate.setLocale(newProps.locale, newProps.namespace);
      } else if (newProps.locale && newProps.namespace !== namespace) {
        translate.setLocale(newProps.locale, newProps.namespace);
      }
    }
  }

  componentWillUnmount() {
    const {
      translate
    } = this.state;
    translate.removeListener('locale', this.localeChanged);
    translate.removeListener('changed', this.dataChanged);
  }

  getLocale() {
    const {
      translate
    } = this.state;
    return translate.getLocale();
  }

  setLocale(locale) {
    var _this = this;

    return (0, _asyncToGenerator2.default)(function* () {
      const {
        controlled
      } = _this.props;

      if (controlled) {
        throw new Error('LocaleProvider is set as controlled component. If you want to use setLocale please set controlled = false');
      }

      const {
        translate
      } = _this.state;
      yield translate.setLocale(locale);
    })();
  }

  get(path, attrs, defaultValue) {
    const {
      translate
    } = this.state;
    return translate.get(path, attrs, defaultValue);
  }

  set(path, value) {
    const {
      translate
    } = this.state;
    return translate.set(path, value);
  }

  render() {
    const {
      children
    } = this.props;
    return _react.default.createElement(Provider, {
      value: {
        localeProvider: this
      }
    }, children);
  }

}

exports.default = LocaleProvider;
(0, _defineProperty2.default)(LocaleProvider, "defaultProps", {
  controlled: true
  /*
  locale: undefined,
  namespace: undefined,
  locales: undefined,
  cache: undefined,
  data: undefined,
  adapter: undefined,
  dotNotation: undefined,
  mode: undefined,
  references: undefined,
  variables: undefined,
  combinations: undefined,
  filters: undefined,
  translate: undefined,
  */

});
//# sourceMappingURL=LocaleProvider.js.map