"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _LocaleProvider = require("./LocaleProvider");

var _Namespace = require("./Namespace");

class ProvideTranslate extends _react.Component {
  constructor(..._args) {
    super(..._args);
    (0, _defineProperty2.default)(this, "translate", (path, ...args) => {
      const {
        localeProvider
      } = this.props;
      return localeProvider.get(this.getPath(path), ...args);
    });
  }

  getPath(path) {
    const {
      namespace,
      ignoreNamespace
    } = this.props;

    if (!namespace || ignoreNamespace) {
      return path;
    }

    const parentPath = namespace.getPath();

    if (!parentPath) {
      return path;
    }

    return `${parentPath}.${path}`;
  }

  render() {
    const {
      children
    } = this.props;
    return children(this.translate);
  }

}

(0, _defineProperty2.default)(ProvideTranslate, "defaultProps", {
  ignoreNamespace: false
});

var _default = (0, _react.forwardRef)((props, ref) => _react.default.createElement(_LocaleProvider.LocaleProviderConsumer, null, ({
  localeProvider
}) => _react.default.createElement(_Namespace.NamespaceConsumer, null, ({
  namespace
}) => _react.default.createElement(ProvideTranslate, (0, _extends2.default)({}, props, {
  localeProvider: localeProvider,
  namespace: namespace,
  ref: ref
})))));

exports.default = _default;
//# sourceMappingURL=ProvideTranslate.js.map