import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { forwardRef, Component } from 'react';
import { LocaleProviderConsumer } from './LocaleProvider';

class LocaleSwitch extends Component {
  constructor(...args) {
    var _this;

    _this = super(...args);

    _defineProperty(this, "handleChange",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(function* (locale) {
        const {
          onError,
          onChange,
          localeProvider
        } = _this.props;

        try {
          yield localeProvider.setLocale(locale);

          if (onChange) {
            onChange(locale);
          }
        } catch (e) {
          if (onError) {
            onError(e);
          }
        }
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }

  render() {
    const {
      children,
      localeProvider
    } = this.props;
    return children({
      locale: localeProvider.getLocale(),
      changeLocale: this.handleChange
    });
  }

}

_defineProperty(LocaleSwitch, "defaultProps", {
  onError: undefined,
  onChange: undefined
});

export default forwardRef((props, ref) => React.createElement(LocaleProviderConsumer, null, ({
  localeProvider
}) => React.createElement(LocaleSwitch, _extends({}, props, {
  localeProvider: localeProvider,
  ref: ref
}))));
//# sourceMappingURL=LocaleSwitch.js.map