import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { forwardRef, Component } from 'react';
import { LocaleProviderConsumer } from './LocaleProvider';
import { NamespaceConsumer } from './Namespace';

class ProvideTranslate extends Component {
  constructor(..._args) {
    super(..._args);

    _defineProperty(this, "translate", (path, ...args) => {
      const {
        localeProvider
      } = this.props;
      return localeProvider.get(this.getPath(path), ...args);
    });
  }

  getPath(path) {
    const {
      namespace,
      ignoreNamespace
    } = this.props;

    if (!namespace || ignoreNamespace) {
      return path;
    }

    const parentPath = namespace.getPath();

    if (!parentPath) {
      return path;
    }

    return `${parentPath}.${path}`;
  }

  render() {
    const {
      children
    } = this.props;
    return children(this.translate);
  }

}

_defineProperty(ProvideTranslate, "defaultProps", {
  ignoreNamespace: false
});

export default forwardRef((props, ref) => React.createElement(LocaleProviderConsumer, null, ({
  localeProvider
}) => React.createElement(NamespaceConsumer, null, ({
  namespace
}) => React.createElement(ProvideTranslate, _extends({}, props, {
  localeProvider: localeProvider,
  namespace: namespace,
  ref: ref
})))));
//# sourceMappingURL=ProvideTranslate.js.map